(***************************************************************************)
(* ListHelpFile, entpackt Borland-Helpfiles                                *)
(* diese knnen mit hl.exe wieder komprimiert werden                       *)
(* Version: 1.00 940808                                                    *)
(***************************************************************************)
program ListHelpFile;

uses extstrings, filename;

const
  Version = 'Version 1.00a vp940808';

const
  OF_CaseSense = $0004;        { option flag: index is case sensitive }
  CT_Nibble = 2;               { compression type: nibble compression }
  NC_RawChar = $F;             { nibble code: raw char }
  NC_RepChar = $E;             { nibble code: repeat char }

type
  TPVersionRec = record
    FormatVersion: Byte;
    TextVersion: Byte;
  end;
  RecType =
    (RT_FileHeader,
    RT_Context,
    RT_Text,
    RT_Keyword,
    RT_Index,
    RT_Compression,
    RT_IndexTags);
  TPrecHdr = record
    RecType: RecType;
    RecLength: Word;
  end;
  TPfileHdrRec = record
    Options: Word;
    MainIndexScreen: Word;
    MaxScreenSize: Word;
    Height: Byte;
    Width: Byte;
    LeftMargin: Byte;
  end;
  TPCompRec = record
    CompType: Byte;
    CharTable: array[0..13] of Byte;
  end;
  TPKeyWordRec = record
    UpContext: Word;
    DownContext: Word;
    KeyWordCnt: Word;
  end;

  PContextArray = ^TContextArray;
  TContextArray = ARRAY[0..16000] OF LongInt;
  TPContextRec = record
    b1, b2, b3 : Byte;
  end;
  String32 = String[32];
  PPIndexRec = ^TPIndexRec;
  TPIndexRec = record
    Index : Word;
    IndexEntry: String32;
    ContextNumber: Word;
    next: PPIndexRec;
  end;
  PPIndexTagsRec = ^TPIndexTagsRec;
  TPIndexTagsRec = record
    wIndexNumber: word;
    IndexTagsEntry: String;
    next: PPIndexTagsRec;
  end;

var
  f: file;
  ftext: text;
  fileHdrRec: TPfileHdrRec;
  CompRec: TPCompRec;
  ContextArray: PContextArray;
  ContextNum: Word;
  Idx: PPIndexRec;
  KeyWordRec: TPKeyWordRec;
  IndexTagsRec: PPIndexTagsRec;

procedure error(s : String);
begin
  writeln(HexL(filepos(f)),'h: ',s);
  close(f); close(ftext);
  halt(255);
end;

function GetStringZ: string;
var
  s : String;
  b : Byte;
begin
  b := 0;
  repeat
    inc(b);
    blockread(f, s[b], sizeof(Char));
  until s[b]=#0;
  s[0] := Char(b-1);
  GetStringZ := s;
end;

procedure ListAdministrative;
var
  c: Char;
  i: Integer;
  VersionRec: TPVersionRec;
begin
  { File Stamp ------------------------------------------------------------ }
  write(ftext, ';STAMP ');
  writeln(ftext, GetStringZ);
  blockread(f,c,SizeOf(Char));
  if c<> #$1A then error('$1a after stamp expected');
  { File Signature -------------------------------------------------------- }
  write(ftext, ';SIGNATURE ');
  writeln(ftext, GetStringZ);
  { File Version ---------------------------------------------------------- }
  blockread(f, VersionRec, sizeof(TPVersionRec));
  writeln(ftext, ';VERSION ', VersionRec.TextVersion);
  case VersionRec.FormatVersion of
    52:;
    51: begin
          writeln(ftext, ';COMMENT FormatVersion 51 (TP60)');
          writeln(ftext, ';COMMENT patch 34h into 33h on fileposition ',
           HexL(filepos(f)-2),'h');
        end;
    else begin
      writeln('FormatVersion ', VersionRec.FormatVersion);
      error('I can''t handle this FormatVersion');
    end;
  end;
end;

type Nibble  = $0..$F;
var  GetNext:  Boolean;
     ThisByte: Byte;
     len: Word;
     ScreenNum, OldScreenNum : Word;

function GetNibble: Nibble;
begin
  if GetNext then		       { Wieder ein neues Byte holen? }
    begin
      blockread(f,ThisByte,1);         { Ja: Byte lesen }
      dec(len);	                       { Lnge herunterzhlen }
      GetNibble:=ThisByte and $0F;     { Niederwertiges Nibble isolieren }
      ThisByte:=ThisByte shr 4;        { Hherwertiges Nibble vorbereiten }
      GetNext:=false;		       { Beim nchsten Mal nicht lesen }
    end
  else
    begin
      GetNibble:=ThisByte;	       { Zweites Nibble des letzten Bytes }
      GetNext:=true;		       { Beim nchsten Mal wieder lesen }
    end;
end;

function GetTextChar: Char;
var
  i: Integer;
  n,n1: Nibble;
  b: Byte;
  c: char;
begin
  n := GetNibble;
  case n of
    $00: writeln(ftext);
    $01 .. $0D: write(ftext, Char(CompRec.CharTable[n]));
    NC_RepChar: begin
      n := GetNibble; { number-2 of repeats }
      n1 := GetNibble; { type of repeating char }
      case n1 of
        $00: for i := 1 to n+2 do writeln(ftext);
        $01 .. $0D: for i := 1 to n+2 do write(ftext, Char(CompRec.CharTable[n1]));
        NC_RepChar: error('NC_RepChar nested');
        NC_RawChar: begin
          b := $10*GetNibble + GetNibble;
          for i := 1 to n+2 do write(ftext, Char(b));
        end;
      end;
    end;
    NC_RawChar: begin
      b := $10*GetNibble + GetNibble;
      if b=1 then exit;
      write(ftext, Char(b));
    end;
  end;
end;

function GetScreenNum(l : LongInt) : Word;
var w : Word;
begin
  for w := 0 to ContextNum-1 do
    if ContextArray^[w] = l then begin
      GetScreenNum := w;
      exit;
    end;
  GetScreenNum := $FFFF;
end;

procedure ListRecord;
var
  oldfilepos: LongInt;
  recHdr: TPrecHdr;
  ContextRec: TPContextRec;
  i,j: Integer;
  w: Word;
  b: Byte;
  c: Char;
  s: String32;
  p,p_old,p_save: PPIndexRec;
  q,q_old: PPIndexTagsRec;
  IndexTagsPoint : Word;
  indx : Word;
  isTagged : Boolean;

begin
  oldfilepos := filepos(f);
  blockread(f, recHdr, sizeof(TPrecHdr));

  case recHdr.RecType of
    RT_FileHeader: { ----------------------------------- File Header Record }
      begin
        blockread(f, fileHdrRec, sizeof(TPfileHdrRec));
        if fileHdrRec.Options AND OF_CaseSense <> 0 then
          writeln(ftext, ';CASESENSE');
        writeln(ftext, ';HEIGHT ', fileHdrRec.Height);
        writeln(ftext, ';WIDTH ', fileHdrRec.Width);
        writeln(ftext, ';LMARGIN ', fileHdrRec.LeftMargin);
      end;
    RT_Context: { ------------------------------------------- Context Table }
      begin
        blockread(f, ContextNum, SizeOf(ContextNum)); { number of contexts }
        if ContextNum>16000 then error('too much context entries');
        new(ContextArray);
        for i := 0 to ContextNum-1 do begin
          blockread(f, ContextRec, SizeOf(ContextRec));
          ContextArray^[i] := $10000*LongInt(ContextRec.b3)
            + $100*LongInt(ContextRec.b2) + ContextRec.b1;
        end;
      end;
    RT_Text: { ------------------------------------------------ Text record }
      begin
        len := recHdr.RecLength;
        GetNext := True;
        writeln(ftext);
        writeln(ftext);
        OldScreenNum := ScreenNum;
        ScreenNum := GetScreenNum(oldfilepos);
        if KeyWordRec.DownContext <> 0 then begin { folgt vom letzten Screen }
          if KeyWordRec.DownContext <> ScreenNum then
            error('bad page numbering (DownContext)');
          writeln (ftext, ';PAGE ', ScreenNum)          { ein page-Verweis? }
        end else if ScreenNum = $FFFF then                { ein Blindgnger }
          writeln(ftext, ';SCREEN noscreen', oldfilepos)
        else
          writeln(ftext, ';SCREEN ', ScreenNum);      { ein normaler Screen }
        while len > 0 do GetTextChar;
      end;
    RT_Keyword: { ------------------------------------------ Keyword record }
      begin
        blockread(f, KeyWordRec, sizeof(TPKeyWordRec));
        if KeyWordRec.UpContext <> 0 then
        if KeyWordRec.UpContext <> OldScreenNum then
          error('bad page numbering (UpContext)');
        for i := 1 to KeyWordRec.KeyWordCnt do begin
          blockread(f, w, SizeOf(w));
          writeln(ftext, ';KEYWORD ', w);
        end;

        isTagged := false;
        p:=Idx;
	while p<>nil do	begin
	  if p^.ContextNumber=ScreenNum then begin

            q := IndexTagsRec;
            while q<>nil do begin
              if q^.wIndexNumber = p^.Index then
                if not isTagged then begin
                  writeln(ftext, ';SCREENTAG ', q^.IndexTagsEntry);
                  isTagged := true;
                end;
              q := q^.next;
            end;

            writeln(ftext, ';INDEX ', p^.IndexEntry);
          end;
          p:=p^.next;
          inc(w);
        end;

        if ScreenNum = fileHdrRec.MainIndexScreen then
          writeln(ftext, ';MAININDEX');
        if KeyWordRec.DownContext = 0 then writeln(ftext, ';ENDSCREEN');
      end;
    RT_Index: { ----------------------------------------------- Index Table }
      begin
        blockread(f, w, SizeOf(w)); { number of index descriptors }
        Idx:=NIL;
        s:=''; indx := 0;
        for i := 0 to w-1 do begin
          New(p);
          if Idx<>NIL then
            p_old^.next:=p
          else
            Idx:=p;
          blockread(f,b,sizeof(b));	  { Lngenbyte lesen }
          s:=copy(s,1,(b shr 5) and $07); { Obere 3 Bits geben an, wieviele Zei-
                                            chen vom letzten Sw genommen werden }
          b:=b and $1F;	                  { Untere 5 Bits geben Restlnge an }
          for j:=1 to b do		  { Soviele Zeichen holen }
	    begin
              blockread(f,b,sizeof(b));
	      s := s+char(b);
	    end;
          p^.IndexEntry:=s;

          blockread(f,p^.ContextNumber,sizeof(p^.ContextNumber)); { ContextNumber }
          p_old:=p;
          p_old^.next:=NIL;
          p^.Index := indx; inc(indx);
        end;
      end;

    RT_Compression: { ---------------------------------- Compression Record }
      begin
        blockread(f, CompRec, sizeof(CompRec));
        if CompRec.CompType <> CT_Nibble then
          error('comptype ct_nibble expected');
      end;
      RT_IndexTags: { ----------------------------------------- Screen tags }
      begin
        q := nil;
        while filepos(f) < oldfilepos + recHdr.RecLength + SizeOf(recHdr) do begin
          q_old := q;
          new(q);
          q^.next := q_old;
          blockread(f,q^.wIndexNumber,sizeof(q^.wIndexNumber));
          blockread(f,b,sizeof(b)); { TextLnge }
          q^.IndexTagsEntry := GetStringZ;
          if q^.wIndexNumber = $FFFF then writeln(ftext, ';DESCRIPTION ', q^.IndexTagsEntry);
        end;
        IndexTagsRec := q;
      end;
  end;

  if filepos(f) <> oldfilepos + recHdr.RecLength + SizeOf(recHdr) then begin
    write(filepos(f), ' ', oldfilepos + recHdr.RecLength+ SizeOf(recHdr), ' ');
    error('bad record');
  end;
end;



(***************************************************************************)

const
  clk :string[4] = '\|/-';
var
  fn, programm: TFileName;
  i : Integer;

begin
  writeln;
  programm.SetPath(paramstr(0));
  writeln('Borland HelpFile Lister        ', Version);
  if paramcount <> 1 then begin
    writeln('decompiles Borland helpfiles into textfiles (*.hlx)');
    writeln('usage: ', programm.filename, ' [ helpfile ]');
    exit;
  end;
  assign(f, paramstr(1));
  fn.SetPath(paramstr(1));
  assign(ftext, fn.filename+'.hlx');
  reset(f,1); rewrite(ftext);
  writeln(ftext,';CBEGIN');
  writeln(ftext,'***************************************************************************');
  writeln(ftext,'          Borland helpfile ',fn.filenameext);
  writeln(ftext,'          created with ', programm.filenameext,' ', Version);
  writeln(ftext,'***************************************************************************');
  writeln(ftext,';CEND');
  writeln(ftext);

  write('i''m working  ');
  ListAdministrative;
  KeyWordRec.DownContext := 0;
  KeyWordRec.UpContext := 0;
  ScreenNum := $FFFF;
  i := 1;
  repeat
    ListRecord;
    write(#8,clk[i]);
    inc(i); if i > 4 then i := 1;
  until eof(f);
  writeln(#8,'done');
  writeln(ftext);
  writeln(ftext,';COMMENT thats all folks');
  close(f); close(ftext);
end.